#
# tkcon.tcl --
#
#   Wrapper script to either load or deiconify tkcon from Trillian.
#
#
# $Header: /home/cvs/tcllian/src/tcl/tkcon-loader.tcl,v 1.10 2005/01/03 05:54:33 dossy Exp $
#

namespace eval ::tkconLoader {
    proc start {} {
        variable entry_id
        # Add the Tkcon entry to the group.
        if {![info exists entry_id]} {
            set entry_id -1
        }
        if {$entry_id == -1} {
            set entry_id [trillian listAddEntry \
                section_id $::tcllian::section_id \
                parent_id $::tcllian::group_id \
                real_name "tkcon" text "tkcon" \
                callback [list ::tkconLoader::listCallback]]
        }
    }

    proc stop {} {
        variable entry_id
        trillian listRemoveEntry $entry_id
        set entry_id -1
    }

    proc listCallback {event args} {
        switch -- $event {
            list_leftDoubleClick {
                if {[llength [info command ::tkcon]] == 0} {
                    namespace eval ::tkcon {}
                    if {[info exists ::argv0]} {
                        unset ::argv0       ;# so that tkcon "properly" embeds
                    }
                    set ::tkcon::PRIV(showOnStartup) 0
                    set ::tkcon::PRIV(protocol) {tkcon hide}
                    set ::tkcon::OPT(exec) ""   ;# we want to have only the main interpreter

                    ::tcllian::load tkcon.tcl

                    bind . <<TkCon_Exit>> {tkcon hide}
                    bind . <<TkCon_Close>> {tkcon hide}
                    .mbar.file entryconfigure 3 -command {tkcon hide}

                    ::tkcon show
                } else {
                    ::tkcon show
                }
            }
        }
        return 0
    }
}

